<?php

namespace Microsoft\Graph\Generated\Users\Item\ContactFolders\Item;

use Microsoft\Kiota\Abstractions\QueryParameter;

/**
 * Get a contact folder by using the contact folder ID. There are two scenarios where an app can get another user's contact folder:
*/
class ContactFolderItemRequestBuilderGetQueryParameters 
{
    /**
     * @QueryParameter("%24expand")
     * @var array<string>|null $expand Expand related entities
    */
    public ?array $expand = null;
    
    /**
     * @QueryParameter("%24select")
     * @var array<string>|null $select Select properties to be returned
    */
    public ?array $select = null;
    
    /**
     * Instantiates a new ContactFolderItemRequestBuilderGetQueryParameters and sets the default values.
     * @param array<string>|null $expand Expand related entities
     * @param array<string>|null $select Select properties to be returned
    */
    public function __construct(?array $expand = null, ?array $select = null) {
        $this->expand = $expand;
        $this->select = $select;
    }

}
